// static/nativeComponents/SharePicture/index.js
const app = getApp()
const { indexApi } = app;
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    datas: {
      type: Object
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    tabIndex : 0,
    waterfallLeftList:[],
    waterfallRightList:[],
    loaded : true,
    pageNum : 1,
    tabId : 1,
  },
  ready(){
    this.queryBuyingShowList(0);
  },

  /**
   * 组件的方法列表
   */
  methods: {
    tabHandle(e){
      let index = e.currentTarget.dataset.index
      let item = e.currentTarget.dataset.item
      console.log(index, item, this.data.tabIndex)
      if(this.data.tabIndex != index){
        this.setData({
          tabIndex: index,
          tabId: item.id
        })
        this.queryBuyingShowList(0)
      }
     
    },
    queryBuyingShowList(type){
      if (this.data.datas.componentData["activityFlag"][0]["id"] == "" || !this.data.loaded){

        return;
      }
      this.setData({
        loaded : false
      })
      if(type == 0){
        this.setData({
          pageNum : 1
        })
      }else{
        this.setData({
          pageNum : this.data.pageNum + 1
        })
      }
      let query = {
        activityId: this.data.datas.componentData.activityFlag[0].id || 4,
        sortType: this.data.tabId,
        pageNum: this.data.pageNum,
        startTime: Array.isArray(this.data.datas.componentData.publishTime)
          ? this.data.datas.componentData.publishTime[0]
          : "",
        endTime: Array.isArray(this.data.datas.componentData.publishTime)
          ? this.data.datas.componentData.publishTime[1]
          : "",
        pageSize: +this.data.datas.componentData["quantity"]
      }

      indexApi.queryBuyingShowList(query).then(res => {
        this.setData({
          loaded :true
        })
        if(res.data.code == '200'){
          let data = res.data.data
          let { waterfallLeftList, waterfallRightList} = this.data
          if(type == 0){
            data.forEach((item,index) => {
              item.customerHandImage = app.DFSImg(item.customerHandImage)
              item.checkMP4Status = this.checkMP4(item.urls)
              if (this.getFileType(item.urls[0]) == 'video'){
                item.coverImg = app.DFSImg(`${item.urls[0]}?x-oss-process=video/snapshot,t_1,m_fast`)
              }else{
                item.coverImg = app.DFSImg(item.urls[0], 400, null, 1)
              }

              if(index % 2 == 0){
                waterfallLeftList.push(item)
              }else{
                waterfallRightList.push(item)
              }
            })

            this.setData({
              waterfallLeftList,
              waterfallRightList
            })

            console.log(this.data.waterfallLeftList, this.data.waterfallRightList,' this.data.waterfallRightList')
          }else{

          }
        }
      })
      .catch(err => {
        this.setData({
          loaded: true
        })
      })


    },
    getFileType(name) {
      if (!name) return false;
      var imgType = ["gif", "jpeg", "jpg", "bmp", "png"];
      var videoType = [
        "avi",
        "wmv",
        "mkv",
        "mp4",
        "mov",
        "rm",
        "3gp",
        "flv",
        "mpg",
        "rmvb"
      ];
      if (
        RegExp(".(" + imgType.join("|") + ")$", "i").test(name.toLowerCase())
      ) {
        return "image";
      } else if (
        RegExp(".(" + videoType.join("|") + ")$", "i").test(name.toLowerCase())
      ) {
        return "video";
      } else {
        return false;
      }
    },
    checkMP4(data) {
      for (let index = 0; index < data.length; index++) {
        if (this.getFileType(data[index]) == "video") {
          return true;
        } else {
          return false;
        }
      }
    },
  }
})
